//*****************************************************************************
//!
//! @file $Id: mc_interface.c 2047 2008-09-12 13:50:36Z raubree $
//!
//! Copyright (c) 2008 Atmel.
//!
//! @brief d@ł̲̪֐񋟂܂B
//!
//! @todo
//! @bug
//*****************************************************************************

/* 쌠 (c) 2008, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ _______________________________________________________________
#include "config.h"

#include "mc_interface.h"
#include "mc_control.h"
#include "mc_drv.h"

Bool mci_direction = CW;					//!< d@ݒ肷邽߂̎gpғҰ
Bool mci_run_stop = FALSE;					//!< d@Jn܂͒~邽߂̎gpғҰ
U8 mci_ref_speed = 0;						//!< d@xݒ肷邽߂̎gpғҰ

U16 mci_measured_period = (U16)K_SPEED;		//!< d@x𓾂邽߂̓d@Ұ
U32 mci_measured_current = 0;				//!< d@d𓾂邽߂̓d@Ұ
U8 mc_potentiometer_value = 0;				//!< d@xݒ肷邽߂̓d@Ұ

extern Bool overcurrent;

extern U8 new_position;
extern U8 ru_step_length;
extern U8 ru_period_counter;
extern U8 ramp_up_index;
extern U8 motor_state;

/**
* @brief	mci_runҰœd@𓮂܂B
* @pre		ʰ޳ƿĳ̏
* @post		ΰٕϐɐVl
*/
void mci_run(void)
{
  if (!(PCTL & (1<<PRUN)))				/* ߓd̏ꍇA */
  {
	PSC_Init();
  }
  overcurrent = FALSE;
  mci_run_stop = TRUE;
  mc_regulation_loop();
  mc_disable_during_inrush();			/* Aߓd֎~ */
  new_position = MS_001;
  mc_switch_commutation((Motor_Position)new_position);
  mc_duty_cycle(ALIGN_DUTY);
  ru_period_counter = ALIGN_TIME;
  motor_state=MS_ALIGN;
  ru_step_length = RAMP_UP_STEP_MAX;
  ramp_up_index = 0;
}

/**
* @brief	mci_retry_run͑x̏ꍇɑsĎs܂B
* @pre		ʰ޳ƿĳ̏
* @post		ΰٕϐɐVl
*/
void mci_retry_run(void)
{
  mci_run_stop = TRUE;
  mc_regulation_loop();
  mc_switch_commutation(mc_get_hall());
  mc_disable_during_inrush();			/* Aߓd֎~ */
}

/**
* @brief	d@̏Ԏ擾
* @pre		ʰ޳ƿĳ̏
* @post		d@sۂm܂B
*/
Bool mci_motor_is_running(void)
{
  return mci_run_stop;
}

/**
* @brief	mci_stop͓d@~܂BđxlؾĂ܂B
* @pre		d@s(mci_run executed)
* @post		d@~
*/
void mci_stop(void)
{
  mci_run_stop=FALSE;
  motor_state=MS_STOP;
  mc_duty_cycle(0);						// d@d=0
}

/**
* @brief	۸яɎgp
* @post		ʰ޳ƿĳ̌`Ԑݒ
*/
void mc_init()
{
  mc_init_HW();
  Enable_interrupt();
  mci_stop();
  mci_forward();
  mci_set_ref_speed(0);
  mc_set_measured_period(K_SPEED);
}

/*
* @brief	xύX
* @pre		d@̏
* @post		x̐Vl
*/
void mci_set_ref_speed(U8 speed)
{
  if ( (motor_state!=MS_ALIGN)
	 ||(motor_state!=MS_RAMP_UP)
	 ||(motor_state!=MS_LAST_RAMP_UP))
  {
	mci_ref_speed = speed;
  }
}

/*
* @brief	xl擾
* @pre		d@̏
* @post		xl擾
*/
U8 mci_get_ref_speed(void)
{
  return mci_ref_speed;
}

/*
* @brief	]ύX
* @pre		d@̏
* @post		̐Vl
*/
void mci_forward(void)
{
  mci_direction = CW;
}

/*
* @brief	t]ύX
* @pre		d@̏
* @post		̐Vl
*/
void mci_backward(void)
{
  mci_direction = CCW;
}

/*
* @brief	l擾
* @pre		d@̏
* @post		l擾
*/
U8 mci_get_motor_direction(void)
{
  return mci_direction;
}

/**
 * @brief	xݒ(p)
 * @pre		Ȃ
 * @post	mci_measured_period
*/
void mc_set_measured_period(U16 measured_period)
{
  mci_measured_period = (mci_measured_period * 3 + measured_period * 4) / 4;
}

/**
 * @brief	x
 * @return	x(8ޯ)lԂB
 * @pre		Ȃ
 * @post	Ȃ
*/
U8 mci_get_measured_speed(void)
{
  U16 measured_speed;

  if (mci_measured_period == 0) {mci_measured_period += 1 ;}	// 0Zx
  measured_speed = (K_SPEED * 4)/ (mci_measured_period);
  if(measured_speed > 255) measured_speed = 255;				// ϐOa

  return measured_speed;
}

/**
* @brief	d@d擾
* @pre		A/Dϊv敔Jn
* @post		A/Dϊ12̌(8ޯĂ̓dl)擾
*/
U16 mci_get_measured_current(void)
{
  return mci_measured_current/64;
}

/**
* @brief	̂߂'mc_measured_current'ϐݒ
* @pre		Ȃ
* @post		currentl'mc_measured_current'ݒ
*/
void mci_store_measured_current(U16 current)
{
  mci_measured_current = ((63*mci_measured_current)+(64*current))>>6;
}

/**
* @brief	ϒRl擾
* @pre		A/Dϊv敔Jn
* @post		A/Dϊ6̌(8ޯẲϒRl)擾
*/
U8 mc_get_potentiometer_value(void)
{
  return mc_potentiometer_value;
}

/**
* @brief	ϒRl'mc_potentiometer_value'ϐݒ
* @pre		A/Dϊv敔Jn
* @post		ϒRl'mc_potentiometer_value'ݒ
*/
void mc_set_potentiometer_value(U8 potentiometer)
{
  mc_potentiometer_value = potentiometer;
}

